<template>
    <div class="row" v-if="ready">
        <div class="content">
            <h3 class="main-header">Подать заявку на займ</h3>
            <div class="warning-block white-block" v-if="$user.blankFields.length">
                <b>Внимание</b><br>
                Для полного доступа ко всем услугам,
                <router-link to="/profile">дозаполните анкету</router-link>
                .
            </div>
            <div class="white-block">
                <!--<credit-rate @change="calcChange" :service-price="additionalServicesPrice"></credit-rate>-->
                <calculator v-model="loan" :service-price="additionalServicesPrice" ref="calc"/>
            </div>
            <graphic-payment v-if="$loanType === 8"></graphic-payment>
            <div class="white-block">
                <div class="padding">
                    <h3>Выберите способ получения денег</h3>
                </div>
                <hr/>
                <div class="padding">
                    <div class="row">
                        <div class="columns four">
                            <div>
                                <label>Способ получения</label>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="columns six">
                            <!--<withdraw-select v-if="firsttime" :name="'withdrawtype'" @select="handleSelect"></withdraw-select>-->
                            <accounts-drop-box v-model="selectedPayMethod" :name="'test'"></accounts-drop-box>
                        </div>
                        <div class="columns six">
                            <p>{{ dynamicHint }}</p>
                        </div>
                    </div>
                    <component :is="dynamicComponent" v-model='inputedCard'></component>
                </div>
            </div>
        </div>

        <div class="white-block" v-if="hasAdditionalService && services.length">
            <div class="padding">
                <h3>Дополнительные услуги</h3>
            </div>
            <hr>
            <div class="services">
                <div class="service" v-for="(/**iAdditionalService**/service) in services" :key="service.id">
                    <div class="service-header">
                        <div class="checkbox">
                            <ui-checkbox v-model="service.selected"></ui-checkbox>
                        </div>
                        <div class="title" @click="setServiceSelected(service.id, service.selected)">{{service.title}}</div>
                        <div class="label-block">
                            <div class="price arrow">{{calculateServicePrice(service)|currency}} ₽</div>
                            <div class="price" v-if="service.period_label">{{service.period_label}}</div>
                        </div>

                        <div class="details" :class="{expand: service.selected}" @click="setServiceExpand(service.id)">
                            Условия предоставления услуги
                            <SVGIcon xlink="collapse-20" fill="#4d92e3" viewBox="0 0 24 24" :rotate="service.expand ? 180 : 0"/>
                        </div>
                    </div>
                    <div class="body" v-show="service.expand">
                        {{blockDescription(service)}}

                        <div v-if="service.document_url" class="docs" @click="openDocument(service.document_url)">
                            <div class="link">{{service.document_title}}</div>
                        </div>
                    </div>
                </div>
            </div>

        </div>

        <div class="white-block" v-if="!$user.qa">
            <div class="padding">
                <h3>Идентификация</h3>
            </div>
            <hr>
            <control-question ref="qa"/>
        </div>

        <div class="white-block">
            <div class="row">
                <div class="padding checkbox">
                    <input name="agree" id="agree" type="checkbox" v-model="isRulesAgreed">
                    <label for="agree" ref="rules"><span></span>
                        Я даю согласие на <a @click.prevent="$modal.show('consent')" href="#">обработку</a>
                        и
                        хранение моих персональных данных,
                        я согласен на запрос и передачу моих персональных данных в бюро кредитных историй,
                        я ознакомлен и согласен с <a
                                @click.prevent="openPopup('https://static.webbankir.com/public/docs/regulations.pdf')"
                                href="#">правилами</a>
                        и <a @click.prevent="openPopup('https://static.webbankir.com/public/docs/rules.pdf')"
                             href="#">информацией</a>
                        предоставления займа ООО МФК «ВЭББАНКИР»,
                        я подтверждаю, что указанные мной мои данные в заявлении на предоставление микрозайма
                        достоверны.</label>
                </div>
            </div>
        </div>

        <div class="center button__container" >
            <button @click="create"
                    :disabled="$store.getters.getButtonLoading || !$calculate.status.available"
                    :class="{button_loading: $store.getters.getButtonLoading}">
                Подать заявку
            </button>
            <div class="repay-amount" v-if="$refs.calc">
                Сумма к возврату: {{$refs.calc.returnAmount|currency}} ₽
            </div>
        </div>

        <not-available v-if="!$calculate.status.available"></not-available>

        <consent-to-the-processing-of-personal-data></consent-to-the-processing-of-personal-data>
        <modal-additional-services v-if="$config.serviceModalEnabled"
                                   :insured="isInsured"
                                   :legal="isLegal"
                                   ref="modalAdditionalServices"/>
        <card-exp-modal ref="cardExpModal" :account="selectedPayMethod"></card-exp-modal>
    </div>
    <ajax-loader v-else></ajax-loader>
</template>

<script>
    import NotAvailable from './NotAvailable';
    import CreditRate from '@/components/CreditRate';
    import Multiselect from '@/UI/Multiselect';
    import ErrorHandleMixin from '@/mixins/ErrorHandleMixin';
    import AccountsDropBox from './AccountsDropBox';
    import NewAccountCard from '@/components/AccountsAdd/NewAccountCard';
    import NewAccountContact from '@/components/AccountsAdd/NewAccountContact';
    import NewAccountYandex from '@/components/AccountsAdd/NewAccountYandex';
    import ConsentToTheProcessingOfPersonalData
        from '@/pages/Registration/FirstPage/ConsentToTheProcessingOfPersonalData';
    import { SET_STATUS } from '@/store/mutation-types';
    import CardForm from '@/components/CardForm';
    import YandexPurse from '@/components/TypeGetMoney/YandexPurse';
    import ContactGiveMoney from '@/components/TypeGetMoney/ContactGiveMoney';
    import InsuranceCheckbox from '@/components/Modals/InsuranceCheckbox';
    import CheckForInsurance from '@/mixins/Loans/CheckForInsurance';
    import reverse from 'lodash/reverse';
    import debounce from 'lodash/debounce';
    import legal from '@/components/Chunks/Legal.vue';
    import AdditionalServiceChunk from '@/components/Chunks/AdditionalServiceChunk.vue';
    import modalAdditionalServices from '@/components/Modals/AdditinalServices.vue';
    import ControlQuestion from '@/components/User/ControlQuestion';
    import GraphicPayment from '@/components/GraphicPayment';
    import Inn from '@/mixins/Inn.js';
    import pdl from '@/mixins/pdl';
    import AdditionalServices from '@/mixins/Loans/AdditionalServices';
    import cardExpModal from '@/components/Modals/CardExp';
    import ServicesMixin from '@/mixins/Loans/Services.js';
    import SVGIcon from '@/components/SVGIcon';
    import Calculator from '@/components/Calculator';



    export default {
        name: 'NewLoan',
        props: {
            firsttime: {
                type: Boolean,
                default: false
            }
        },
        components: {
            CreditRate,
            NotAvailable,
            ControlQuestion,
            modalAdditionalServices,
            InsuranceCheckbox,
            ConsentToTheProcessingOfPersonalData,
            Multiselect,
            AccountsDropBox,
            NewAccountCard,
            NewAccountContact,
            NewAccountYandex,
            ContactGiveMoney,
            YandexPurse,
            CardForm,
            legal,
            AdditionalServiceChunk,
            GraphicPayment,
            cardExpModal,
            SVGIcon,
            Calculator
        },
        mixins: [
            ErrorHandleMixin,
            Inn,
            pdl,
            AdditionalServices,
            ServicesMixin
        ],
        data() {
            return {
                creating: false,
                installment: 0,
                promoCode: '',
                inputedCard: null,
                selectedPayMethod: null,
                isRulesAgreed: true,
                isInsuredInternal: null,
                isLegalInternal: null,
                calcConfig: null,
                oldPercent: 0,
                blockPromo: false,
                promoShow: false,
                promoIsValid: false,
                dynamicComponent: null,
                dynamicHint: '',
                btnText: '',
                countMonth: 1,
                codesToComponents: {
                    'card': 'new-account-card',
                    'contact': 'contact-give-money',
                    'yandex': 'yandex-purse'
                },
                withdrawHints: {
                    'card': 'У вас есть банковская карта: вы можете получить займ прямо на нее в течение 10 минут. Это самый быстрый и безопасный способ!',
                    'contact': 'Займ можно будет получить в любом удобном вам Пункте Обслуживания CONTACT!',
                    'yandex': 'Все паспортные данные владельца кошелька Яндекс.Деньги должны полностью совпадать с данными, которые вы указали на первом шаге оформления займа.'
                },
                btnTexts: {
                    'card': ' карту',
                    'contact': ' кошелек',
                    'yandex': ' кошелек'
                },
                controlQuestionTypeStatus: [
                    {
                        id: 1,
                        title: 'Кличка домашнего животного'
                    },
                    {
                        id: 2,
                        title: 'Девичья фамилия матери'
                    },
                    {
                        id: 3,
                        title: 'Свой вопрос'
                    }
                ],
                fieldControlQuestionType: {
                    id: 1,
                    title: 'Кличка домашнего животного'
                },
                sum_max: 15000,// для кеша максимальной суммы, если мы меняем на киви, то максимальная сумма может уменьшиться.
                loan: {
                    days: 10,
                    sum: 7500
                }

            };
        },
        computed: {
            insuranceCheckBox() {
                return this.$calculate.insurance.status && this.$loanType === 1;
            },

            legalIsAllowed() {
                return this.$calculate.legal && this.$calculate.legal.status && this.$config.legalEnabled;
            },
            insuranceParameters: CheckForInsurance.computed.insuranceParameters,
            insuranceIsAllowed() {
                const bDay = this.$user.bDay;
                if (this.$pdl.id || !bDay) {
                    return false;
                }
                try {
                    const dateString = reverse(bDay.split('.'))
                        .join('/');
                    const today = new Date();
                    const birthDate = new Date(dateString);
                    let age = today.getFullYear() - birthDate.getFullYear();
                    const m = today.getMonth() - birthDate.getMonth();
                    if (m < 0 || (m === 0 && today.getDate() < birthDate.getDate())) {
                        age--;
                    }
                    return age <= 74;
                } catch (e) {
                    return false;
                }
            },
            disableContinueButton() {
                return !(this.selectedPayMethod && this.isRulesAgreed) || (this.$user.blocked);
            },
            accounts() {
                return this.$store.getters.getAccounts.map(account => ({
                    ...account,
                    label: account.name ? account.name : account.description
                }));
            },
            isInsured: {
                get() {
                    return this.isInsuredInternal !== null ? this.isInsuredInternal : !!this.insuranceIsAllowed;
                },
                set(newVal) {
                    this.isInsuredInternal = newVal;
                }
            },
            isLegal: {
                get() {
                    if (!this.$config.legalEnabled) {
                        return false;
                    }
                    return this.isLegalInternal !== null ? this.isLegalInternal : !!this.legalIsAllowed;
                },
                set(newVal) {
                    this.isLegalInternal = newVal;
                }
            },
        },
        watch: {
            installment: debounce(function (installment) { // sum был заменен installment
                if (installment >= 30000) {
                    this.getPaymentGraph();
                }
            }, 1000),

            'loan.days': debounce(function (days) {
                if (days > 30) {
                    this.getPaymentGraph();
                }
            }, 1000),

            isRulesAgreed(state) {
                if (state) {
                    this.$refs.rules.style.color = '';
                }
            },
            'loan.sum': {
                immediate: true,
                handler () {
                    this.$emit('change', this.loan.sum);
                    this.$store.commit('LOAN_SET_LOAN_TYPE', this.loan.sum > 20000 ? 8 : 1);

                }
            }
        },

        async created() {
            this.AJAX_LOADING(true);
            await this.$store.dispatch('ADDITIONAL_SERVICES_LOAD_LIST');
            this.AJAX_LOADING(false);
            this.getUserLocation();
        },

        beforeMount() {
            this.addErrorFields(['Промокод']);
        },

        mounted() {
            this.selectedPayMethod = this.$accounts.find((account) => account.main === 1);

            // контакт по умолчанию, если не задан другой главный аккаунт
            if (!this.selectedPayMethod) {
                this.selectedPayMethod = this.$accounts.find((account) => account.type === 5);
            }
            this.sum = this.$calculate.sum_max / 2;
        },
        methods: {
            getPaymentGraph() {
                let today = this.$dayjs(new Date)
                    .format('YYYY-MM-DD');
                this.$store.dispatch('GET_GRAPHIC_INSTALLMENT', [this.sum, this.countMonth, today]);
            },
            // calcChange(calculate) {
            //     this.$set(this, 'sum', calculate.sum);
            //     this.sum = calculate.sum;
            //     this.installment = calculate.sum;
            //     this.days = calculate.days;
            //     this.countMonth = calculate.countMonth;
            // },
            changeLegalState(state) {
                this.isLegal = state;
            },
            addErrorFields(fields) {
                fields.forEach(field => this.$validator.attach({ name: field }));
            },
            async create() {
                // проверка на заполненость анкеты
                if (this.$user.blankFields.length) {
                    this.$toastr.error('Для подачи заявки на займ, Вам необходимо полностью заполнить анкету.', 'Ошибка');
                    return;
                }
                // проверка на принятие правил
                if (!this.isRulesAgreed) {
                    this.$toastr.error('Вы не дали согласие на обработку и хранение персональных данных', 'Ошибка');
                    this.$refs.rules.style.color = '#ff6d4a';
                    this.$helpers.scroll(this.$refs.rules);
                    return;
                }

                // если трубется контольный вопрос/ответ, то сначала валидируем, потом сохраняем.
                let canCreateLoan;
                if (!this.$user.qa) {
                    if (!await this.$refs.qa.$validator.validateAll()) {
                        this.$toastr.error('Заполните поле контрольный ответ', 'Ошибка');
                        this.$helpers.focus();
                        return;
                    } else {
                        this.BUTTON_LOADING(true);
                        canCreateLoan = await this.$backend.api.user.additional.fill({
                            controlQuestion: this.$user.controlQuestion,
                            controlQuestionType: this.$user.controlQuestionType,
                            controlAnswer: this.$user.controlAnswer
                        })
                            .then(() => {
                                this.$user.qa = true;

                                return true;
                            })
                            .catch((e) => {
                                const errors = [];
                                if (e.errors[0].code === 'alreadyHaveControlQuestion') {
                                    return true;
                                }

                                e.errors.forEach((error) => {
                                    switch (error.code) {
                                        case 'controlAnswerTooLong':
                                            errors.push('Контрольный ответ слишком длинный');
                                            break;
                                        case 'controlAnswerTooShort':
                                            errors.push('Контрольный ответ слишком короткий');
                                            break;
                                        case 'controlQuestionTooShort':
                                            errors.push('Контрольный вопрос слишком короткий');
                                            break;
                                        case 'controlQuestionTooLong':
                                            errors.push('Контрольный вопрос слишком длинный');
                                            break;
                                        case 'snilsInvalidFormat':
                                            errors.push('Некорректный СНИЛС');
                                            break;
                                        case 'snilsCodeIncorrect':
                                            errors.push('Некорректный СНИЛС');
                                            break;
                                        case 'snilsOrInnCodeIncorrect':
                                            errors.push('Неверно введен СНИЛС или ИНН');
                                            break;
                                        case 'alreadyHaveControlQuestion':
                                            errors.push('Вы уже зарегистрированны. Перейдите в личный кабинет.');
                                            break;
                                    }
                                });
                                this.$toastr.error('При подаче заявки произошли ошибки: <br> - ' + errors.join('-<br>'), 'Ошибка');
                                return false;
                            })
                            .finally(() => {
                                this.$store.commit('BUTTON_LOADING', false);
                            });
                    }
                } else {
                    canCreateLoan = true;
                }

                if (!canCreateLoan) {
                    return false;
                }

                if(this.selectedPayMethod?.type === 1 && this.selectedPayMethod?.has_exp === false) {
                    if(!this.$refs.cardExpModal._events.set) {
                        console.log('this.selectedPayMethod', 'addEvent');
                        this.$refs.cardExpModal.$on('set', (state) => {
                            if (state) {
                                this.$modal.hide('card-exp-modal');
                                this.selectedPayMethod.has_exp = true;
                                this.createLoan();
                            } else {
                                this.$toastr.error('Не удалось обновить данные карты. Попробуйте еще раз или добавьте новую карту', 'Ошибка')
                            }
                        })
                    }
                    this.$modal.show('card-exp-modal');
                    return;
                }

                if (this.$config.serviceModalEnabled) {
                    if ((!this.isInsured && this.insuranceIsAllowed) || (!this.isLegal && this.$calculate.legal.status)) {
                        this.$modal.show('modal-additional-services', {
                            insuredPrice: this.insuranceParameters.price,
                            insuredAmount: this.insuranceParameters.sum,
                            legalPrice: this.$calculate.legal.sum,
                            legalPeriod: this.$calculate.legal.period
                        });
                        // исключаем дублирование евентов, если окно вызвано несколько раз
                        if (!this.$refs.modalAdditionalServices._events.answer) {
                            this.$refs.modalAdditionalServices.$on('answer', (answer) => {
                                this.isInsured = answer.insured;
                                this.isLegal = answer.legal;
                                this.$modal.hide('modal-additional-services');
                                window.wbEvent.send('CLIENT_SIGN_CONTRACT');
                                this.createLoan();
                            });
                        }
                    } else {
                        this.createLoan();
                    }
                } else {
                    this.createLoan();
                }
            },
            async createLoan(double = false) {
                if (this.creating) {
                    return false; //WB-4284
                }

                this.creating = true;
                this.AJAX_LOADING(true);
                const additionalServices = await this.getSelectedAdditionalServices();

                if (this.$loanType === 8) {
                    if (!this.$user.snilsOrInn || String(this.$user.snilsOrInn).length !== 12) {
                        this.sendInnCheck();
                    }
                }

                if (this.$loanType === 8) {
                    this.isInsured = 0;
                }

                /** @type LoanObject */
                const loanObj = {
                    sum: this.loan.sum,
                    days: this.loan.days,
                    services: {
                        insurance: 0,
                        legal: 0
                    },
                    promoCode: this.promoCode,
                    paySystem: this.selectedPayMethod.type,
                    accountId: this.selectedPayMethod.id,
                    screenX: window.screen.width,
                    screenY: window.screen.height,
                    browserInfo: navigator.userAgent,
                    deviceInfo: '',
                    latitude: this.$store.getters.getUserLocation.latitude || null,
                    longitude: this.$store.getters.getUserLocation.longitude || null,
                    platform: 1,
                    additionalServices
                };
                this.$store.commit(SET_STATUS, 'creatingLoan');
                this.$store.commit('BUTTON_LOADING', true);
                this.AJAX_LOADING({
                    waitingTitle: 'Отправка заявки',
                    isShow: true
                });
                if (window.yaCounter17582872) window.yaCounter17582872.reachGoal('SEC_LOAN');

                const action = this.sum >= 30000 ? 'LOAN_INSTALLMENT_CREATE' : 'LOAN_CREATE';
                this.$store.dispatch(action, loanObj)
                    .then((response) => {
                        this.$backend.log({
                            loan: {
                                ...loanObj,
                                sum: 0
                            },
                            newuser: false,
                            loan_num: Array.isArray(this.$history) ? this.$history.filter(l => l.type === 1).length : 0,
                            loan_id: this.$pdl.id,
                        });
                        window.wbEvent.send('CLIENT_APPLY_LOAN_PRIMARY');
                        window.wbEvent.send('CLIENT_APPLY_LOAN_AGAIN');
                        this.$toastr.success('Заявка отправлена на рассмотрение. Ожидайте решения по SMS', 'Успешно');
                        this.$nextTick(() => {
                            this.$helpers.scroll(this.$root.$el);
                            this.$store.commit('BUTTON_LOADING', false);
                        });

                        this.$store.dispatch('GET_LOAN_PDL');
                        this.$store.dispatch('GET_LOAN_POS');
                    })
                    .catch(async (e) => {
                        console.log('%c-------------------------', 'color: red');
                        console.warn('catch', e);
                        console.log('%c-------------------------', 'color: red');

                        if (Array.isArray(e.errors) && e.errors[0] && e.errors[0].code) {
                            this.$backend.log({
                                user_login: this.$user.login,
                                user_id: this.$user.id,
                                user_phone: this.$user.phone,
                                errors: JSON.stringify(e.errors),
                                error_type: 'loan_request',
                                sum: e.errors[0].code === 'maximumSumError' ? loanObj.sum : undefined,
                                pay_system: this.selectedPayMethod.type,
                                account_id: this.selectedPayMethod.id
                            });

                            switch (e.errors[0].code) {
                                case 'promoCreationError':
                                    this.$toastr.error('Повторная акционная заявка или по ранее введенному промокоду запрещена.', 'Ошибка');
                                    break;
                                case 'doubleLoan':
                                    // сначала попробуем получить займ...
                                    await this.$store.dispatch('GET_LOAN_PDL');
                                    if (this.$pdl.id) {
                                        this.$helpers.scroll(this.$root.$el);
                                    } else {
                                        this.$toastr.error('Повторите подачу заявки через 5 минут.', 'Ошибка');
                                    }
                                    break;
                                case 'countLoanInYearError':
                                    this.$toastr.error('Превышен лимит займов', 'Ошибка');
                                    break;
                                case 'activeLoanError':
                                    this.$toastr.error('У вас уже есть активный займ', 'Ошибка');
                                    break;
                                case 'accountError':
                                    this.$toastr.error('Не удалось найти выбранный способ получения. Попробуйте выбрать другой', 'Ошибка');
                                    break;
                                case 'errorCreatingLegal':
                                    this.$toastr.error('Ошибка создания договора оказания юр.услуг', 'Ошибка');
                                    break;
                                case 'maximumSumError':
                                    this.$toastr.error('Превышена максимальная сумма займа', 'Ошибка');
                                    break;
                                // если страховка запрещена, то пытаемся повторить запрос без нее.
                                case 'errorCreatingInsurance':
                                case 'forbiddenInsuranceService':
                                    if (double) {
                                        this.$toastr.error('Ошибка взятия займа - не удалось создать договор страхования', 'Ошибка');
                                        return;
                                    }
                                    this.isInsured = false;
                                    this.creating = false;
                                    this.createLoan(true);
                                    break;
                                case 'clientIsBlocked':
                                    this.AJAX_LOADING(true);
                                    this.$methods.user.getUserData()
                                        .finally(() => {
                                            this.AJAX_LOADING(false);
                                            this.$helpers.scroll(this.$root.$el);
                                        });
                                    break;

                                default:
                                    this.$toastr.error('При отправлении заявки произошла ошибка. Попробуйте снова через несколько минут', 'Ошибка');
                                    break;
                            }
                        } else {
                            this.$toastr.error('При отправлении заявки произошла ошибка. Попробуйте снова через несколько минут', 'Ошибка');
                            this.$backend.log({
                                user_login: this.$user.login,
                                user_id: this.$user.id,
                                user_phone: this.$user.phone,
                                errors: 'Unknown',
                                error_type: 'loan_request'
                            });
                        }
                        this.$store.commit('BUTTON_LOADING', false);
                    })
                    .finally(() => {
                        this.$store.commit(SET_STATUS, 'ok');
                        this.creating = false;
                        this.AJAX_LOADING(false);
                    });


            },
            sendPromoCode() {
                this.getCalcConfig();
            },
            async getCalcConfig() {
                try {
                    console.log('============================', this.$store.dispatch('getCalculatorParameters'));
                    const { data } = await this.$store.dispatch('getCalculatorParameters', this.promoCode);
                    this.vErrors.remove('Промокод');
                    this.oldPercent = this.calcConfig.percent;
                    this.$store.commit('LOAN_SET_CALC', data.data);
                    this.promoIsValid = true;
                } catch (e) {
                    if (e.code === 'tooManyTries') {
                        this.blockPromo = true;
                    }
                }
            }
        },
    };
</script>

<style scoped lang="scss">
    @import "static/css/variables/media.scss";
    @import "static/css/variables/color.scss";


    .button__container {
        display: flex;
        align-items: center;
        justify-content: center;

        margin-bottom: 40px;

        & > button {
            margin-bottom: 0;
        }
        & .repay-amount {
            color: $titleColor;
        }
    }

    @media #{$mobile} {
        .button__container {
            margin-bottom: 0;
            position: fixed;
            display: block;
            bottom: 0;
            left: 0;
            background: #fff;
            box-shadow: 0 0 30px 0 rgba(0, 0, 0, 0.1);
            width: 100%;
            z-index: 10;
            & button {
                margin: 10px 0 !important;
            }

        }
    }
</style>
